CREATE OR REPLACE TRIGGER USR_ATU_NOTAFISCAL_NGD
BEFORE DELETE OR UPDATE OF IDSTATUSNFE
ON NOTAFISCAL  FOR EACH ROW
DECLARE
  V_CHAVE       VARCHAR2(300);
BEGIN
   IF DELETING THEN
      SELECT NVL(MAX(CDFILIEMIT), '')
        INTO V_CHAVE
        FROM USR_ITEMPRODUTO_NGD
       WHERE USR_ITEMPRODUTO_NGD.CDFILIAL     <> :NEW.CDFILIAL
         AND USR_ITEMPRODUTO_NGD.NRLANCTONF   <> :NEW.NRLANCTONF
         AND USR_ITEMPRODUTO_NGD.CDFILIEMIT   =  :NEW.CDFILIEMIT
         AND USR_ITEMPRODUTO_NGD.CDFILIRECE   =  :NEW.CDFILIRECE
         AND USR_ITEMPRODUTO_NGD.DTENTRSAID   =  :NEW.DTENTRSAID;
      IF V_CHAVE = '' THEN
         UPDATE USR_ITEMPRODUTO_NGD
            SET IDSTATUSITMNF      = 'INATIVO',
                TPINTERFACE        = 'E',
                DTINTERFACEORI     = SYSDATE,
                DTINTERFACEDEST    = NULL,
                STATUS             = '1'
          WHERE USR_ITEMPRODUTO_NGD.CDFILIAL     = :NEW.CDFILIAL
            AND USR_ITEMPRODUTO_NGD.NRLANCTONF   = :NEW.NRLANCTONF;
         INSERT
           INTO USR_LOG_NGD(IDPROCESSO, DTLOG, STATUS, OBSSTATUS, IDPESQITEM)
         VALUES ('USR_ITEMPRODUTO_NGD', SYSDATE, '0', NULL, :NEW.CDFILIEMIT||'-'||:NEW.CDFILIRECE||'-'||:NEW.DTENTRSAID);
      ELSE
         UPDATE ITEMPRODUTO
            SET USR_NGD_INTEGRADO = 'N'
          WHERE ITEMPRODUTO.CDFILIAL        <> :NEW.CDFILIAL
            AND ITEMPRODUTO.NRLANCTONF      <> :NEW.NRLANCTONF
            AND NVL(USR_NGD_INTEGRADO, 'N') =  'S'
            AND EXISTS(SELECT 1
                         FROM NOTAFISCAL
                        WHERE NOTAFISCAL.CDFILIAL   =  ITEMPRODUTO.CDFILIAL
                          AND NOTAFISCAL.NRLANCTONF =  ITEMPRODUTO.NRLANCTONF
                          AND NOTAFISCAL.IDENTRSAIDOP = 'S'
                          AND NOTAFISCAL.IDSTATUSNFE  = 'A'
                          AND NOTAFISCAL.CDFILIAL   <> :NEW.CDFILIAL
                          AND NOTAFISCAL.NRLANCTONF <> :NEW.NRLANCTONF
                          AND NOTAFISCAL.CDFILIEMIT =  :NEW.CDFILIEMIT
                          AND NOTAFISCAL.CDFILIRECE =  :NEW.CDFILIRECE
                          AND NOTAFISCAL.DTENTRSAID =  :NEW.DTENTRSAID);
      END IF;
   ELSE
      IF :NEW.IDSTATUSNFE <> 'A' THEN
         UPDATE USR_ITEMPRODUTO_NGD
            SET IDSTATUSITMNF      = 'INATIVO',
                TPINTERFACE        = 'E',
                DTINTERFACEORI     = SYSDATE,
                DTINTERFACEDEST    = NULL,
                STATUS             = '1'
          WHERE USR_ITEMPRODUTO_NGD.CDFILIAL   = :NEW.CDFILIAL
            AND USR_ITEMPRODUTO_NGD.NRLANCTONF = :NEW.NRLANCTONF;
         INSERT
           INTO USR_LOG_NGD(IDPROCESSO, DTLOG, STATUS, OBSSTATUS, IDPESQITEM)
         VALUES ('USR_ITEMPRODUTO_NGD', SYSDATE, '0', NULL, :NEW.CDFILIEMIT||'-'||:NEW.CDFILIRECE||'-'||:NEW.DTENTRSAID);
      ELSIF :NEW.IDSTATUSNFE = 'A' THEN
         UPDATE ITEMPRODUTO
            SET USR_NGD_INTEGRADO = 'N'
          WHERE ITEMPRODUTO.CDFILIAL        = :NEW.CDFILIAL
            AND ITEMPRODUTO.NRLANCTONF      = :NEW.NRLANCTONF
            AND NVL(USR_NGD_INTEGRADO, 'N') =  'S';
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_ATU_NOTAFISCAL_NGD','6.39.030'); END;
/
